<template>
  <v-row justify="center">
    <v-btn class="mt-16" color="success" @click="addCourse">Add Course</v-btn>
    <v-dialog v-model="dialog" scrollable max-width="600px">
      <v-card>
        <v-card-title>Add a Course</v-card-title>
        <v-divider></v-divider>
        <v-card-text style="height: 600px;">
          <v-container>
            <v-text-field
              v-model="course.title"
              label="Course Title"
              required
            ></v-text-field>

            <v-text-field
              v-model="course.description"
              label="Course Description"
              required
            ></v-text-field>

            <v-text-field
              v-model="course.author"
              label="Author"
              required
            ></v-text-field>

            <v-text-field
              v-model="course.picture"
              label="Course's Picture"
              required
            ></v-text-field>

            <v-text-field
              v-model="course.author_picture"
              label="Author's Picture"
              required
            ></v-text-field>

            <v-text-field
              v-model="course.price"
              label="Price"
              required
              prepend-icon="mdi-currency-usd"
            ></v-text-field>
          </v-container>
        </v-card-text>
        <v-divider></v-divider>
        <v-card-actions>
          <v-btn color="blue darken-1" text @click="dialog = false">
            Close
          </v-btn>
          <v-btn color="blue darken-1" text @click="submitCourse">
            Submit
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-snackbar v-model="snack" :timeout="3000" :color="snackColor">
        {{ snackText }}
        <template v-slot:action="{ attrs }">
          <v-btn v-bind="attrs" text @click="snack = false">
            Close
          </v-btn>
        </template>
      </v-snackbar>
  </v-row>
</template>
<script>
import axios from "axios";
import { mapActions, mapGetters } from "vuex";

export default {
  data() {
    return {
      snack: false,
      snackColor: "",
      snackText: "",
      course: {
        title: "HashiCorp Vault 201 - Vault for Apps in Kubernetes",
        description: `Learn how to use HashiCorp Vault for your applications in Kubernetes`,
        author: "Sam Gabrail",
        picture:
          "https://process.fs.teachablecdn.com/ADNupMnWyR7kCWRvm76Laz/resize=width:705/https://file-uploads.teachablecdn.com/574dedfcfef645e892d50b43416fbef1/9090c902da6a45138e6eb6416f0d7961",
        author_picture:
          "https://process.fs.teachablecdn.com/ADNupMnWyR7kCWRvm76Laz/resize=width:30,height:30/https://www.filepicker.io/api/file/T0m3jgQHSxOk0u9KwMlj",
        price: "139"
      },
      dialog: false
    };
  },
  computed: {
    ...mapGetters(["courses"])
  },
  methods: {
    ...mapActions(["getCourses"]),
    addCourse() {
      this.dialog = true;
      console.log("adding course");
    },
    submitCourse() {
      this.dialog = false;
      console.log("submitting course: ", this.course);
      axios
        .post(`${process.env.VUE_APP_API_ADDRESS}/courses`, this.course, {})
        .then(() => {
          this.getCourses();
          this.snack = true;
          this.snackColor = "success";
          this.snackText = "Course Added";
        })
        .catch(err => console.log(err));
    }
  }
};
</script>
